test_that("is_nlist", {
  expect_false(is_nlist(1))
  expect_false(is_nlist(list(x = 1)))
  expect_true(is_nlist(nlist()))
  expect_true(is_nlist(nlist(x = 1)))
})

test_that("is_nlists", {
  expect_false(is_nlists(1))
  expect_false(is_nlists(list(x = 1)))
  expect_false(is_nlists(nlist()))
  expect_true(is_nlists(nlists()))
  expect_true(is_nlists(nlists(nlist(x = 1))))
})

test_that("niters nlist", {
  expect_identical(niters(nlist()), 1L)
  expect_identical(niters(nlist(x = 1)), 1L)
})

test_that("", {
  expect_identical(niters(nlists()), 0L)
  expect_identical(nsims(nlists(nlist())), 1L)
  expect_identical(nsims(nlists(nlist(), nlist())), 2L)
})

test_that("base R atomic", {
  expect_true(is.atomic(1))
  expect_true(is.atomic(matrix(1)))
  expect_true(is.atomic(array(1)))

  expect_false(is.atomic(list()))
})

test_that("base R numeric", {
  expect_true(is.numeric(1))
  expect_true(is.numeric(matrix(1)))
  expect_true(is.numeric(array(1)))

  expect_true(is.numeric(1L))
  expect_true(is.numeric(matrix(1L)))
  expect_true(is.numeric(array(1L)))

  expect_false(is.numeric(TRUE))
  expect_false(is.numeric(matrix(TRUE)))
  expect_false(is.numeric(array(TRUE)))
})

test_that("as.term.nlist", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    as.term(nlist()),
    term()
  )
  expect_identical(
    as.term(nlist(x = 1)),
    term("x")
  )
  expect_identical(
    as.term(nlist(x = 1:2)),
    term("x[1]", "x[2]")
  )
  expect_identical(
    as.term(nlist(x = 1, y = 2:3)),
    term(c("x", "y[1]", "y[2]"))
  )
  expect_identical(
    as.term(nlist(x = 1, y = matrix(1:3, c(1, 3)))),
    term(c("x", "y[1,1]", "y[1,2]", "y[1,3]"))
  )
})

test_that("as.term.nlists", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    as.term(nlists()),
    term(x = 0)
  )
  expect_identical(
    as.term(nlists(nlist())),
    term(x = 0)
  )
  expect_identical(
    as.term(nlists(nlist(x = 1))),
    term("x")
  )
  expect_identical(
    as.term(nlists(nlist(x = 1:2))),
    term(x = 2)
  )
  expect_identical(
    as.term(nlists(
      nlist(x = 1, y = matrix(1:3, c(1, 3))),
      nlist(x = 1, y = matrix(1:3, c(1, 3)))
    )),
    term("x", y = c(1, 3))
  )
})

test_that("as_term.nlist", {
  expect_identical(
    as_term(nlist()),
    term()
  )
  expect_identical(
    as_term(nlist(x = 1)),
    term("x")
  )
  expect_identical(
    as_term(nlist(x = 1:2)),
    term("x[1]", "x[2]")
  )
  expect_identical(
    as_term(nlist(x = 1, y = 2:3)),
    term(c("x", "y[1]", "y[2]"))
  )
  expect_identical(
    as_term(nlist(x = 1, y = matrix(1:3, c(1, 3)))),
    term(c("x", "y[1,1]", "y[1,2]", "y[1,3]"))
  )
})

test_that("as_term.nlists", {
  expect_identical(
    as_term(nlists()),
    term(x = 0)
  )
  expect_identical(
    as_term(nlists(nlist())),
    term(x = 0)
  )
  expect_identical(
    as_term(nlists(nlist(x = 1))),
    term("x")
  )
  expect_identical(
    as_term(nlists(nlist(x = 1:2))),
    term(x = 2)
  )
  expect_identical(
    as_term(nlists(
      nlist(x = 1, y = matrix(1:3, c(1, 3))),
      nlist(x = 1, y = matrix(1:3, c(1, 3)))
    )),
    term("x", y = c(1, 3))
  )
})

test_that("split_chains nlists", {
  nlists <- nlists(nlist(x = matrix(1:6, 2)), nlist(x = matrix(3:8, 2)))
  nlists2 <- nlists
  attr(nlists2, "nchains") <- 2L

  expect_identical(split_chains(nlists), nlists2)
})

test_that("split_chains nlists error", {
  nlists <- nlists(nlist(x = matrix(1:6, 2)))
  expect_error(split_chains(nlists), "^`x` must have at least two iterations[.]$",
               class = "chk_error")
})

test_that("split_chains nlists extra iters", {
  nlists <- nlists(
    nlist(x = matrix(1:6, 2)), nlist(x = matrix(3:8, 2)),
    nlist(x = matrix(2:7, 2))
  )
  expect_identical(
    split_chains(nlists),
    structure(list(
      structure(list(x = structure(1:6, .Dim = 2:3)), class = "nlist"),
      structure(list(x = structure(3:8, .Dim = 2:3)), class = "nlist")
    ), class = "nlists", nchains = 2L)
  )
})

test_that("as_list_unnamed_nlist", {
  expect_identical(as_list_unnamed_default(nlist()), structure(list(), .Names = character(0)))
  expect_identical(as_list_unnamed_default(nlist(x = 1)), list(x = 1))
  expect_identical(as_list_unnamed_default(nlist(x = matrix(1:4))), list(x = matrix(1:4)))
  expect_identical(as_list_unnamed_default(nlist(x = 1, a = 3)), list(x = 1, a = 3))
})

test_that("as_list.nlists", {
  expect_identical(as_list_unnamed_nlists(nlists(nlist())), list())
  expect_identical(as_list_unnamed_nlists(nlists(nlist(x = 1))), list(x = 1))
  expect_identical(as_list_unnamed_nlists(nlists(nlist(x = matrix(1:4)))), list(x = matrix(1:4)))
  expect_identical(as_list_unnamed_nlists(nlists(nlist(x = 1, a = 3))), list(x = 1, a = 3))
  expect_identical(as_list_unnamed_nlists(nlists(nlist(x = 1), nlist(x = 3))), list(x = 1, x = 3))
  expect_identical(as_list_unnamed_nlists(nlists(nlist(x = 1L), nlist(x = 3L))), list(x = 1L, x = 3L))
})

test_that("nlist", {
  expect_identical(
    set_pars(nlist(x = 1), "y"),
    structure(list(y = 1), class = "nlist")
  )
  expect_identical(
    set_pars(nlist(x = 1, y = 2), c("z", "c1")),
    structure(list(z = 1, c1 = 2), class = "nlist")
  )

  x <- nlist()
  expect_identical(set_pars(x, character(0)), x)
  expect_error(set_pars(x, "a"),
    "^`value` must be length 0, not 1[.]$",
    class = "chk_error"
  )
  x <- nlist(x = 2)
  expect_error(set_pars(x, "."),
    "^`value` must match regular expression",
    class = "chk_error"
  )
})

test_that("nlists", {
  x <- nlists()
  expect_identical(set_pars(x, character(0)), x)
  expect_error(set_pars(x, "a"), "^`value` must be length 0, not 1[.]$", class = "chk_error")
  x <- nlists(nlist())
  expect_identical(set_pars(x, character(0)), x)

  x <- nlists(nlist(x = 2))
  expect_identical(
    set_pars(x, "y"),
    structure(list(structure(list(y = 2), class = "nlist")), class = "nlists")
  )
  x <- nlists(nlist(x = 2), nlist(x = 3))
  expect_identical(
    set_pars(x, "y"),
    structure(list(structure(list(y = 2), class = "nlist"), structure(list(
      y = 3
    ), class = "nlist")), class = "nlists")
  )
  expect_error(set_pars(x, "."),
    "^`value` must match regular expression",
    class = "chk_error"
  )
})

test_that("npdims.nlist", {
  expect_identical(npdims(nlist()), integer(0))
  expect_identical(
    npdims(nlist(x = 1:3, y = matrix(1, c(2, 3)))),
    c(x = 1L, y = 2L)
  )
})

test_that("npdims.nlists", {
  expect_identical(npdims(nlists()), integer(0))
  expect_identical(npdims(nlists(nlist())), integer(0))
  expect_identical(
    npdims(nlists(
      nlist(x = 1:3, y = matrix(1, c(2, 3))),
      nlist(x = 1:3, y = matrix(1, c(2, 3)))
    )),
    c(x = 1L, y = 2L)
  )
})

test_that("dims.nlist", {
  expect_identical(pdims(nlist()), list())
  expect_identical(
    pdims(nlist(x = 1:3, y = matrix(1, c(2, 3)))),
    list(x = 3L, y = 2:1)
  )
})

test_that("pdims.nlists", {
  expect_identical(pdims(nlists()), list())
  expect_identical(pdims(nlists(nlist())), list())
  expect_identical(
    pdims(nlists(
      nlist(x = 1:3, y = matrix(1, c(2, 3))),
      nlist(x = 1:3, y = matrix(1, c(2, 3)))
    )),
    list(x = 3L, y = 2:1)
  )
})

test_that("as_mcmc_list.nlist", {
  expect_identical(
    as_mcmc_list(nlist()),
    structure(list(structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlist(x = 1)),
    structure(list(structure(1, .Dim = c(1L, 1L), .Dimnames = list(
      NULL, "x"
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlist(x = matrix(1:6, 2))),
    structure(list(structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(
      NULL, c(
        "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]",
        "x[2,3]"
      )
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlist(x = 1:2, y = 3)),
    structure(list(structure(c(1, 2, 3), .Dim = c(1L, 3L), .Dimnames = list(
      NULL, c("x[1]", "x[2]", "y")
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlist(x = NA_real_, y = 1)),
    structure(list(structure(c(NA, 1), .Dim = 1:2, .Dimnames = list(
      NULL, c("x", "y")
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )

  expect_identical(
    as_mcmc_list(nlist::nlist(x = 1, y = matrix(1:4, 2))),
    structure(list(structure(c(1, 1, 2, 3, 4), .Dim = c(1L, 5L), .Dimnames = list(
      NULL, c("x", "y[1,1]", "y[2,1]", "y[1,2]", "y[2,2]")
    ), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")), class = "mcmc.list")
  )
})

test_that("as_mcmc_list.nlists", {
  expect_identical(
    as_mcmc_list(nlists()),
    structure(list(structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlists(nlist())),
    structure(list(structure(numeric(0), .Dim = 1:0, .Dimnames = list(
      NULL, NULL
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlists(nlist(), nlist())),
    structure(list(structure(numeric(0), .Dim = c(2L, 0L), .Dimnames = list(
      NULL, NULL
    ), mcpar = c(1, 2, 1), class = "mcmc")), class = "mcmc.list")
  )

  expect_identical(
    as_mcmc_list(nlists(nlist(x = 1))),
    structure(list(structure(1, .Dim = c(1L, 1L), .Dimnames = list(
      NULL, "x"
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlists(nlist(x = 1), nlist(x = 3))),
    structure(list(structure(c(1, 3), .Dim = 2:1, .Dimnames = list(
      NULL, "x"
    ), mcpar = c(1, 2, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    as_mcmc_list(nlists(nlist(x = matrix(1:6, 2)))),
    structure(list(structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(
      NULL, c(
        "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]",
        "x[2,3]"
      )
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )

  expect_identical(
    as_mcmc_list(nlists(
      nlist(x = matrix(1:6, 2)),
      nlist(x = matrix(3:8, 2))
    )),
    structure(list(structure(c(
      1L, 3L, 2L, 4L, 3L, 5L, 4L, 6L, 5L,
      7L, 6L, 8L
    ), .Dim = c(2L, 6L), .Dimnames = list(NULL, c(
      "x[1,1]",
      "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]", "x[2,3]"
    )), mcpar = c(
      1,
      2, 1
    ), class = "mcmc")), class = "mcmc.list")
  )

  nlists <- nlists(nlist(x = matrix(1:6, 2)), nlist(x = matrix(3:8, 2)))
  attr(nlists, "nchains") <- 2L
  expect_identical(
    as_mcmc_list(nlists),
    structure(list(`1` = structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(
      NULL, c(
        "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]",
        "x[2,3]"
      )
    ), mcpar = c(1, 1, 1), class = "mcmc"), `2` = structure(3:8, .Dim = c(
      1L,
      6L
    ), .Dimnames = list(NULL, c(
      "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]",
      "x[1,3]", "x[2,3]"
    )), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
})

test_that("as.mcmc.list.nlist", {
  lifecycle::expect_deprecated(as.mcmc.list(nlist()))
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    coda::as.mcmc.list(nlist()),
    structure(list(structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlist(x = 1)),
    structure(list(structure(1, .Dim = c(1L, 1L), .Dimnames = list(
      NULL, "x"
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlist(x = matrix(1:6, 2))),
    structure(list(structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(
      NULL, c(
        "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]",
        "x[2,3]"
      )
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlist(x = 1:2, y = 3)),
    structure(list(structure(c(1, 2, 3), .Dim = c(1L, 3L), .Dimnames = list(
      NULL, c("x[1]", "x[2]", "y")
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlist(x = NA_real_, y = 1)),
    structure(list(structure(c(NA, 1), .Dim = 1:2, .Dimnames = list(
      NULL, c("x", "y")
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  
  expect_identical(
    coda::as.mcmc.list(nlist::nlist(x = 1, y = matrix(1:4, 2))),
    structure(list(structure(c(1, 1, 2, 3, 4), .Dim = c(1L, 5L), .Dimnames = list(
      NULL, c("x", "y[1,1]", "y[2,1]", "y[1,2]", "y[2,2]")
    ), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")), class = "mcmc.list")
  )
})

test_that("as.mcmc.list.nlists", {
  lifecycle::expect_deprecated(as.mcmc.list(nlists()))
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    coda::as.mcmc.list(nlists()),
    structure(list(structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlists(nlist())),
    structure(list(structure(numeric(0), .Dim = 1:0, .Dimnames = list(
      NULL, NULL
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlists(nlist(), nlist())),
    structure(list(structure(numeric(0), .Dim = c(2L, 0L), .Dimnames = list(
      NULL, NULL
    ), mcpar = c(1, 2, 1), class = "mcmc")), class = "mcmc.list")
  )
  
  expect_identical(
    coda::as.mcmc.list(nlists(nlist(x = 1))),
    structure(list(structure(1, .Dim = c(1L, 1L), .Dimnames = list(
      NULL, "x"
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlists(nlist(x = 1), nlist(x = 3))),
    structure(list(structure(c(1, 3), .Dim = 2:1, .Dimnames = list(
      NULL, "x"
    ), mcpar = c(1, 2, 1), class = "mcmc")), class = "mcmc.list")
  )
  expect_identical(
    coda::as.mcmc.list(nlists(nlist(x = matrix(1:6, 2)))),
    structure(list(structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(
      NULL, c(
        "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]",
        "x[2,3]"
      )
    ), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
  
  expect_identical(
    coda::as.mcmc.list(nlists(
      nlist(x = matrix(1:6, 2)),
      nlist(x = matrix(3:8, 2))
    )),
    structure(list(structure(c(
      1L, 3L, 2L, 4L, 3L, 5L, 4L, 6L, 5L,
      7L, 6L, 8L
    ), .Dim = c(2L, 6L), .Dimnames = list(NULL, c(
      "x[1,1]",
      "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]", "x[2,3]"
    )), mcpar = c(
      1,
      2, 1
    ), class = "mcmc")), class = "mcmc.list")
  )
  
  nlists <- nlists(nlist(x = matrix(1:6, 2)), nlist(x = matrix(3:8, 2)))
  attr(nlists, "nchains") <- 2L
  expect_identical(
    coda::as.mcmc.list(nlists),
    structure(list(`1` = structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(
      NULL, c(
        "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]",
        "x[2,3]"
      )
    ), mcpar = c(1, 1, 1), class = "mcmc"), `2` = structure(3:8, .Dim = c(
      1L,
      6L
    ), .Dimnames = list(NULL, c(
      "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]",
      "x[1,3]", "x[2,3]"
    )), mcpar = c(1, 1, 1), class = "mcmc")), class = "mcmc.list")
  )
})

test_that("c.nlist", {
  expect_identical(c(nlist()), nlist())
  expect_identical(c(nlist(x = 1)), nlist(x = 1))
  expect_error(c(nlist(x = 1), list(x = 1)),
    "^All elements of ... must inherit from S3 class 'nlist'[.]$",
    class = "chk_error"
  )
  expect_identical(c(nlist(x = 1), nlist(y = 2)), nlist(x = 1, y = 2))
  expect_identical(c(nlist(), nlist()), nlist())
  expect_identical(c(nlist(), nlist(x = 1)), nlist(x = 1))
  expect_error(
    c(nlist(x = 1), nlist(x = 1)),
    "^nlist objects must have distinctly named numeric elements in order to be concatenated[.]$"
    , class = "chk_error"
  )
})

test_that("c.nlists", {
  expect_identical(c(nlists()), nlists())
  expect_identical(c(nlists(nlist(x = 1))), nlists(nlist(x = 1)))
  expect_identical(
    c(
      nlists(nlist(x = 1)),
      nlists(nlist(x = 1))
    ),
    nlists(nlist(x = 1), nlist(x = 1))
  )
  expect_error(c(nlists(), list()),
    "^All elements of ... must inherit from S3 class 'nlists'[.]",
    class = "chk_error"
  )
  expect_error(c(
    nlists(nlist(x = 1)),
    nlists(nlist(y = 1))
  ),
  "^nlist elements of [.][.][.] must have matching names[.]$",
  class = "chk_error"
  )
})

test_that("c.nlists with different nchains", {
  nlists <- nlists(nlist(x = 1), nlist(x = 2))
  nlists2 <- nlists
  attr(nlists2, "nchains") <- 2L
  expect_error(
    c(nlists, nlists2),
    "^All elements of ... must have the same number of chains[.]",
    class = "chk_error"
  )
})

test_that("c.nlists with same nchains", {
  nlists <- nlists(nlist(x = 1), nlist(x = 2))
  nlists2 <- nlists(nlist(x = 3), nlist(x = 4))
  attr(nlists, "nchains") <- 2L
  attr(nlists2, "nchains") <- 2L
  expect_identical(
    c(nlists, nlists2),
    structure(list(
      structure(list(x = 1), class = "nlist"), structure(list(
        x = 3
      ), class = "nlist"), structure(list(x = 2), class = "nlist"),
      structure(list(x = 4), class = "nlist")
    ), class = "nlists", nchains = 2L)
  )
})

test_that("c.nlists with same nchains", {
  nlists <- nlists(nlist(x = 1), nlist(x = 2), nlist(x = 3), nlist(x = 4))
  nlists2 <- nlists(nlist(x = 5), nlist(x = 6), nlist(x = 7), nlist(x = 8))
  attr(nlists, "nchains") <- 2L
  attr(nlists2, "nchains") <- 2L
  expect_identical(
    c(nlists, nlists2),
    structure(list(
      structure(list(x = 1), class = "nlist"), structure(list(
        x = 2
      ), class = "nlist"), structure(list(x = 5), class = "nlist"),
      structure(list(x = 6), class = "nlist"), structure(list(x = 3), class = "nlist"),
      structure(list(x = 4), class = "nlist"), structure(list(x = 7), class = "nlist"),
      structure(list(x = 8), class = "nlist")
    ), class = "nlists", nchains = 2L)
  )
})

test_that("is.natomic deprecated", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  lifecycle::expect_deprecated(is.natomic(data.frame()))

  expect_true(is.natomic(1))
})


test_that("is.nlist deprecated", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  lifecycle::expect_deprecated(is.nlist(1))

  expect_false(is.nlist(1))
  expect_true(is.nlist(nlist()))
})

test_that("is.nlists deprecated", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  lifecycle::expect_deprecated(is.nlists(1))

  expect_false(is.nlists(1))
  expect_true(is.nlists(nlists()))
})

test_that("nlist", {
  expect_identical(
    nlist(),
    structure(list(), .Names = character(0), class = "nlist")
  )
  expect_identical(
    nlist(x = 1),
    as_nlist(list(x = 1))
  )
  expect_identical(
    nlist(x = 1, y = 2),
    as_nlist(list(x = 1, y = 2))
  )
  expect_error(
    nlist(x = "x"),
    "no applicable method for 'numericise' applied to an object of class \"character\""
  )
})

test_that("pars.nlist", {
  expect_identical(pars(nlist()), character(0))
  expect_identical(pars(nlist(x = 1)), "x")
  expect_identical(pars(nlist(x = 1, a = 1:10)), c("x", "a"))

  expect_identical(pars(nlist(x = 1, a = 1:10), scalar = TRUE), "x")
  expect_identical(pars(nlist(x = 1, a = 1:10), scalar = TRUE), "x")
  lifecycle::expect_deprecated(pars(nlist(x = 1, a = 1:10), terms = TRUE))
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    pars(nlist(x = 1, a = 1:10), terms = TRUE),
    c("x", "a", "a", "a", "a", "a", "a", "a", "a", "a", "a")
  )
})

test_that("pars.nlists", {
  expect_identical(pars(nlists()), character(0))
  expect_identical(pars(nlists(nlist())), character(0))
  expect_identical(pars(nlists(nlist(x = 1))), "x")
  expect_identical(pars(nlists(nlist(x = 1), nlist(x = 1))), "x")
  expect_identical(pars(nlists(nlist(x = 1, a = 1:10))), c("x", "a"))
  expect_identical(pars(nlists(
    nlist(x = 1, a = 1:10),
    nlist(x = 1, a = 1:10)
  )), c("x", "a"))
})

test_that("pars.nlist scalar", {
  expect_identical(pars(nlist(), scalar = TRUE), character(0))
  expect_identical(pars(nlist(x = 1, a = 1:10), scalar = TRUE), "x")
  expect_identical(pars(nlist(x = 1, a = 1:10), scalar = FALSE), "a")
  expect_identical(pars(nlist(a = 1:10), scalar = TRUE), character(0))
})

test_that("pars.nlists scalar", {
  expect_identical(pars(nlists(), scalar = TRUE), character(0))
  expect_identical(pars(nlists(nlist()), scalar = TRUE), character(0))
  expect_identical(pars(nlists(nlist(), nlist()), scalar = TRUE), character(0))
  expect_identical(pars(nlists(nlist(x = 1, a = 1:10)), scalar = TRUE), "x")
  expect_identical(pars(nlists(nlist(a = 1:10)), scalar = TRUE), character(0))
  expect_identical(pars(nlists(nlist(x = 1, a = 1:10), nlist(x = 2, a = 1:10)), scalar = TRUE), "x")
})

test_that("pars.nlists term", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  lifecycle::expect_deprecated(pars(nlists(nlist(x = 1, a = 1:2)), terms = TRUE))

  expect_identical(pars(nlists(nlist(x = 1, a = 1:2)), terms = TRUE), c("x", "a", "a"))
})

test_that("relist_nlist", {
  expect_identical(relist_nlist(
    structure(numeric(0), .Names = character(0)),
    nlist()
  ), nlist())
  expect_identical(
    relist_nlist(c(a = 5), nlist(a = NA_real_)),
    nlist(a = 5)
  )
  expect_identical(
    relist_nlist(c(a = 5), nlist(a = NA_integer_)),
    nlist(a = 5L)
  )
  expect_identical(
    relist_nlist(c(`a[2]` = 5), nlist(a = c(1, 2, 3))),
    nlist(a = c(NA, 5, NA))
  )
  expect_identical(
    relist_nlist(c(`a[2]` = 5), nlist(a = 1:3)),
    nlist(a = c(NA, 5L, NA))
  )
})

test_that("nlists", {
  expect_identical(
    nlists(),
    structure(list(), class = "nlists")
  )

  expect_identical(
    nlists(nlist()),
    structure(list(structure(list(),
      .Names = character(0),
      class = "nlist"
    )), class = "nlists")
  )
  expect_identical(
    nlists(nlist(x = 1)),
    structure(list(structure(list(x = 1), class = "nlist")),
      class = "nlists"
    )
  )

  expect_identical(
    nlists(nlist(x = 1), nlist(x = 2)),
    structure(list(
      structure(list(x = 1), class = "nlist"),
      structure(list(
        x = 2
      ), class = "nlist")
    ), class = "nlists")
  )

  expect_error(nlists(nlist(x = 1), nlist(y = 2)),
    "^nlist elements of `x` must have matching names[.]$",
    class = "chk_error"
  )
})

test_that("[.nlist", {
  expect_identical(nlist(x = 1)[1], nlist(x = 1))
  expect_identical(nlist(x = 1, y = 2)[1], nlist(x = 1))
  expect_identical(nlist(x = 1, y = 2)["x"], nlist(x = 1))
  expect_identical(nlist(x = 1, y = 2)[2], nlist(y = 2))
  expect_identical(nlist(x = 1, y = 2)["y"], nlist(y = 2))
  expect_error(nlist(x = 1, y = 2)[c(1, 1)], "^`names[(]x[)]` must be unique[.]$",
    class = "chk_error"
  )
  expect_error(nlist(x = 1)[1, ], "incorrect number of dimensions")
})

test_that("[.nlists", {
  expect_identical(nlists(nlist(x = 1))[1], nlists(nlist(x = 1)))
  expect_identical(nlists(nlist(x = 1), nlist(x = 1))[1], nlists(nlist(x = 1)))
  expect_identical(
    nlists(nlist(x = 1), nlist(x = 2))[2:1],
    nlists(nlist(x = 2), nlist(x = 1))
  )
  expect_identical(
    nlists(nlist(x = 1), nlist(x = 3))[c(2, 2)],
    nlists(nlist(x = 3), nlist(x = 3))
  )
  expect_identical(nlists(nlist(x = 1))[1, 1], nlists(nlist(x = 1)))
  expect_identical(
    nlists(nlist(x = 1, y = 1), nlist(x = 2, y = 2))[1, 1],
    structure(list(structure(list(x = 1, y = 1), class = "nlist")), class = "nlists")
  )
  expect_identical(
    nlists(nlist(x = 1, y = 1), nlist(x = 1, y = 1))[, 1],
    nlists(nlist(x = 1, y = 1))
  )
  expect_identical(
    nlists(nlist(x = 1, y = 1), nlist(x = 1, y = 1))[, ],
    nlists(nlist(x = 1, y = 1), nlist(x = 1, y = 1))
  )
  expect_identical(
    nlists(nlist(x = 1, y = 1), nlist(x = 1, y = 1))[],
    nlists(nlist(x = 1, y = 1), nlist(x = 1, y = 1))
  )
})

test_that("brackets with chains", {
  nlists <- nlists(nlist(x = 1, y = 2), nlist(x = 2, y = 3), nlist(x = 3, y = 4), nlist(x = 4, y = 5))
  attr(nlists, "nchains") <- 2L
  expect_identical(nlists[1:2, 1:2], nlists)
  expect_identical(nlists[, 1:2], nlists)
  expect_identical(nlists[1:2, ], nlists)
  expect_identical(nlists[, ], nlists)
  expect_identical(nlists[], structure(list(
    structure(list(x = 1, y = 2), class = "nlist"),
    structure(list(x = 2, y = 3), class = "nlist"), structure(list(
      x = 3, y = 4
    ), class = "nlist"), structure(list(
      x = 4,
      y = 5
    ), class = "nlist")
  ), class = "nlists"))
  expect_identical(
    subset(nlists, pars = c("y", "x")),
    structure(list(
      structure(list(y = 2, x = 1), class = "nlist"),
      structure(list(y = 3, x = 2), class = "nlist"), structure(list(
        y = 4, x = 3
      ), class = "nlist"), structure(list(
        y = 5,
        x = 4
      ), class = "nlist")
    ), class = "nlists", nchains = 2L)
  )
  expect_identical(
    subset(nlists, chains = c(1, 1, 1)),
    structure(list(
      structure(list(x = 1, y = 2), class = "nlist"),
      structure(list(x = 2, y = 3), class = "nlist"), structure(list(
        x = 1, y = 2
      ), class = "nlist"), structure(list(
        x = 2,
        y = 3
      ), class = "nlist"), structure(list(x = 1, y = 2), class = "nlist"),
      structure(list(x = 2, y = 3), class = "nlist")
    ), class = "nlists", nchains = 3L)
  )
  expect_identical(
    subset(nlists, pars = "x", iters = c(2, 2)),
    structure(list(
      structure(list(x = 2), class = "nlist"), structure(list(
        x = 2
      ), class = "nlist"), structure(list(x = 4), class = "nlist"),
      structure(list(x = 4), class = "nlist")
    ), class = "nlists", nchains = 2L)
  )
})

test_that("unlist_nlist", {
  expect_identical(
    unlist_nlist(nlist()),
    structure(numeric(0), .Names = character(0))
  )
  expect_identical(
    unlist_nlist(nlist(z = NA)),
    c(z = NA_real_)
  )
  expect_identical(
    unlist_nlist(nlist(y = 2, x = matrix(4:7, ncol = 2))),
    c(y = 2, `x[1,1]` = 4, `x[2,1]` = 5, `x[1,2]` = 6, `x[2,2]` = 7)
  )
})

test_that("unlist.nlists not defined", {
  expect_error(
    unlist(nlists()),
    "^`unlist[(][)]` is not defined for nlists objects[.]$"
  )
})

test_that("nterms.nlist", {
  expect_identical(nterms(nlist()), 0L)
  expect_identical(nterms(nlist(x = 1)), 1L)
  expect_identical(nterms(nlist(x = 2:3)), 2L)
  expect_identical(nterms(nlist(x = 2:3, y = 1)), 3L)
  expect_identical(nterms(nlist(x = 2:3, y = matrix(1:9))), 11L)
})

test_that("nterms.nlists", {
  expect_identical(nterms(nlists()), 0L)
  expect_identical(nterms(nlists(nlist())), 0L)

  expect_identical(nterms(nlists(nlist(x = 1))), 1L)
  expect_identical(nterms(nlists(nlist(x = 2:3))), 2L)
  expect_identical(nterms(nlists(nlist(x = 2:3, y = 1))), 3L)
  expect_identical(nterms(nlists(nlist(x = 2:3, y = matrix(1:9)))), 11L)
  expect_identical(nterms(nlists(
    nlist(x = 2:3, y = matrix(1:9)),
    nlist(x = 2:3, y = matrix(1:9))
  )), 11L)
})

test_that("as_nlist.numeric", {
  expect_s3_class(as_nlist(c(x = 1)), "nlist")
  expect_error(as_nlist(1), "^`x` must be named[.]$", class = "chk_error")
  expect_error(as_nlist(c(x = 1, x = 2)), "^`names[(]x[)]` must be unique[.]$", class = "chk_error")
  expect_error(as_nlist(c(`x[1]` = 1, `x[1,2]` = 2)), "^All elements of term vector `names[(]x[)]` must be consistent[.]$", class = "chk_error")
  expect_identical(as_nlist(c(`a[2]` = 1, `a[1]` = 2)), structure(list(a = c(2, 1)), class = "nlist"))
  expect_identical(as_nlist(c(`a[2]` = 3L, `a[1]` = 2L)), structure(list(a = c(2L, 3L)), class = "nlist"))
  y <- nlist(g = matrix(1:4, ncol = 2), z = 1:3)
  expect_equal(as_nlist(unlist_nlist(y)), y)
})


test_that("as_nlist.numeric incomplete", {
  expect_identical(as_nlist(c(`a[3]` = 1, `a[1]` = 2)), structure(list(a = c(2, NA, 1)), class = "nlist"))
  expect_identical(as_nlist(c(`a[3]` = 1L, `a[1]` = 2L)), structure(list(a = c(2L, NA, 1L)), class = "nlist"))
})

test_that("as_nlist.list", {
  expect_s3_class(as_nlist(list(x = 1)), "nlist")
  expect_error(as_nlist(list(1)), "^`x` must be named[.]$", class = "chk_error")
})

test_that("as_nlist.mcmc", {
  #  expect_identical(as_nlist(as_mcmc(nlist())), nlist())
  #  expect_identical(as_nlist(as_mcmc(nlist(x = numeric(0)))), nlist())
  expect_identical(as_nlist(as_mcmc(nlist(x = 1))), nlist(x = 1))
  expect_identical(as_nlist(as_mcmc(nlist(x = 1, y = 2))), nlist(x = 1, y = 2))
  expect_identical(as_nlist(as_mcmc(nlist(x = matrix(1:12, nrow = 3)))), nlist(x = matrix(1:12, nrow = 3)))
})

test_that("as_nlist.mcmc.list", {
  #  expect_identical(as_nlist(as_mcmc(nlist())), nlist())
  #  expect_identical(as_nlist(as_mcmc(nlist(x = numeric(0)))), nlist())
  expect_identical(as_nlist(as_mcmc_list(nlist(x = 1))), nlist(x = 1))
  expect_identical(as_nlist(as_mcmc_list(nlist(x = 1, y = 2))), nlist(x = 1, y = 2))
  expect_identical(as_nlist(as_mcmc_list(nlist(x = matrix(1:12, nrow = 3)))), nlist(x = matrix(1:12, nrow = 3)))
  expect_identical(as_nlist(as_mcmc_list(nlists(nlist(x = matrix(1:12, nrow = 3))))), 
                   nlist(x = matrix(1:12, nrow = 3)))
  expect_error(as_nlist(as_mcmc_list(nlists(nlist(x = 1), nlist(x = 2)))),
               "`x` must have one iteration.", class = "chk_error")
})

test_that("as_nlist.nlist", {
  expect_identical(as_nlist(nlist()), nlist())
  expect_identical(as_nlist(as_nlist(list(x = 1))), as_nlist(list(x = 1)))
})

test_that("as_nlist.data.frame", {
  expect_identical(
    as_nlist(data.frame(
      lgl = c(TRUE, NA),
      int = 1:2,
      dbl = c(2.5, 1.5),
      dte = as.Date(c("2001-01-02", "2001-01-01")),
      fac = factor(c("b", "a"))
    )),
    structure(list(
      lgl = c(1L, NA), int = 1:2, dbl = c(2.5, 1.5),
      dte = c(11324, 11323), fac = 2:1
    ), class = "nlist")
  )
})

test_that("as.nlist deprecated", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  lifecycle::expect_deprecated(as.nlist(data.frame(x = 1)))
  expect_identical(
    as.nlist(data.frame(x = 1)),
    as_nlist(data.frame(x = 1))
  )
})

test_that("print.nlist", {
  skip_on_covr()
  expect_identical(
    capture.output(print(nlist())),
    "an nlist object with 0 numeric elements"
  )
  expect_identical(
    capture.output(print(nlist(x = 1))),
    c("$x", "[1] 1", "", "an nlist object with 1 numeric element")
  )
  expect_identical(
    capture.output(print(nlist(x = 1, y = matrix(1:4, 2)))),
    c(
      "$x", "[1] 1", "", "$y", "     [,1] [,2]", "[1,]    1    3",
      "[2,]    2    4", "", "an nlist object with 2 numeric elements"
    )
  )
})

test_that("print.nlists", {
  skip_on_covr()
  expect_identical(
    capture.output(print(nlists())),
    "an nlists object with 0 nlist objects"
  )

  expect_identical(
    capture.output(print(nlists(nlist()))),
    "an nlists object of an nlist object with 0 numeric elements"
  )

  nlist <- nlist(x = 1, y = matrix(1:4, 2))
  nlists <- nlists(nlist, nlist)

  expect_identical(
    capture.output(print(nlists)),
    c(
      "$x", "[1] 1", "", "$y", "     [,1] [,2]", "[1,]    1    3",
      "[2,]    2    4", "", "an nlists object of 2 nlist objects each with 2 numeric elements"
    )
  )
})

test_that("print.nlists multiple chains", {
  skip_on_covr()

  nlist <- nlist(x = 1, y = matrix(1:4, 2))
  nlists <- nlists(nlist, nlist)
  attr(nlists, "nchains") <- 2L

  expect_identical(
    capture.output(print(nlists)),
    c(
      "$x", "[1] 1", "", "$y", "     [,1] [,2]", "[1,]    1    3",
      "[2,]    2    4", "", "an nlists object with 2 chains of an nlist object with 2 numeric elements"
    )
  )
})

test_that("tidy.nlists", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  
  lifecycle::expect_deprecated(tidy(nlists()))
  
  expect_identical(tidy(nlists()), structure(list(
    term = structure(character(0), class = c(
      "term",
      "vctrs_vctr"
    )), estimate = numeric(0), sd = numeric(0), zscore = numeric(0),
    lower = numeric(0), upper = numeric(0), svalue = numeric(0)
  ), row.names = integer(0), class = c(
    "tbl_df",
    "tbl", "data.frame"
  )))
  expect_equal(
    tidy(nlists(nlist())),
    tibble::tibble(
      term = term(x = 0), estimate = numeric(0), sd = numeric(0), zscore = numeric(0),
      lower = numeric(0), upper = numeric(0), svalue = numeric(0)
    )
  )
  expect_identical(
    tidy(nlists(nlist(x = 2))),
    tibble::tibble(
      term = term("x"), estimate = 2, sd = NA_real_, zscore = NA_real_, lower = 2,
      upper = 2, svalue = 1
    )
  )
  expect_identical(
    tidy(nlists(nlist(x = 2:4))),
    tibble::tibble(term = term(x = 3), estimate = c(2, 3, 4), sd = c(
      NA_real_, NA_real_,
      NA_real_
    ), zscore = c(NA_real_, NA_real_, NA_real_), lower = c(
      2,
      3, 4
    ), upper = c(2, 3, 4), svalue = c(1, 1, 1))
  )
  expect_identical(
    tidy(nlists(nlist(y = 1, s = 1:2))),
    tibble::tibble(term = term("y", s = 2), estimate = c(1, 1, 2), sd = c(
      NA_real_, NA_real_,
      NA_real_
    ), zscore = c(NA_real_, NA_real_, NA_real_), lower = c(
      1,
      1, 2
    ), upper = c(1, 1, 2), svalue = c(1, 1, 1))
  )
  expect_equal(tidy(nlists(nlist(x = 1, y = 1:2), nlist(x = 1, y = 3:4))), tibble::tibble(term = term("x" = 1, y = 2), estimate = c(1, 2, 3), sd = c(
    0, 1.4142135623731,
    1.4142135623731
  ), zscore = c(Inf, 1.41421356237309, 2.12132034355964), lower = c(1, 1.05, 2.05), upper = c(1, 2.95, 3.95), svalue = c(
    1.58496250072116,
    1.58496250072116, 1.58496250072116
  )))
})

test_that("tidy.nlists", {
  expect_identical(tidy(nlists(), simplify = TRUE), structure(list(
    term = structure(character(0), class = c(
      "term",
      "vctrs_vctr"
    )), estimate = numeric(0),
    lower = numeric(0), upper = numeric(0), svalue = numeric(0)
  ), row.names = integer(0), class = c(
    "tbl_df",
    "tbl", "data.frame"
  )))
  expect_equal(
    tidy(nlists(nlist()), simplify = TRUE),
    tibble::tibble(
      term = term(x = 0), estimate = numeric(0),
      lower = numeric(0), upper = numeric(0), svalue = numeric(0)
    )
  )
  expect_identical(
    tidy(nlists(nlist(x = 2)), simplify = TRUE),
    tibble::tibble(
      term = term("x"), estimate = 2, lower = 2,
      upper = 2, svalue = 1
    )
  )
  expect_identical(
    tidy(nlists(nlist(x = 2:4)), simplify = TRUE),
    tibble::tibble(term = term(x = 3), estimate = c(2, 3, 4)
                   , lower = c(
      2,
      3, 4
    ), upper = c(2, 3, 4), svalue = c(1, 1, 1))
  )
  expect_identical(
    tidy(nlists(nlist(y = 1, s = 1:2)), simplify = TRUE),
    tibble::tibble(term = term("y", s = 2), estimate = c(1, 1, 2), 
                   lower = c(
      1,
      1, 2
    ), upper = c(1, 1, 2), svalue = c(1, 1, 1))
  )
  expect_equal(tidy(nlists(nlist(x = 1, y = 1:2), nlist(x = 1, y = 3:4)), simplify = TRUE), tibble::tibble(term = term("x" = 1, y = 2), estimate = c(1, 2, 3), 
                                                                                                             lower = c(1, 1.05, 2.05), upper = c(1, 2.95, 3.95), svalue = c(
    1.58496250072116,
    1.58496250072116, 1.58496250072116
  )))
})

test_that("tidy.mcmc", {
  nlists <- nlists(nlist(x = 1:3, y = matrix(1)))
  expect_identical(tidy(as_mcmc(nlists), simplify = TRUE), tidy(nlists, simplify = TRUE))
})

test_that("tidy.mcmc.list", {
  nlists <- nlists(nlist(x = 1:3, y = matrix(1)))
  expect_identical(tidy(as_mcmc_list(nlists), simplify = TRUE), tidy(nlists, simplify = TRUE))
})

test_that("as_term_frame.nlist", {
  expect_equal(
    as_term_frame(nlist()),
    data.frame(term = term::term(0), value = numeric(0))
  )
  expect_identical(as_term_frame(nlist(x = 2:4)), structure(list(term = structure(c("x[1]", "x[2]", "x[3]"), class = c(
    "term",
    "vctrs_vctr"
  )), value = c(2, 3, 4)), row.names = c(NA, -3L), class = "data.frame"))
  expect_identical(as_term_frame(nlist(x = 1, y = 1:2)), structure(list(term = structure(c("x", "y[1]", "y[2]"), class = c(
    "term",
    "vctrs_vctr"
  )), value = c(1, 1, 2)), row.names = c(NA, -3L), class = "data.frame"))
})

test_that("as_term_frame.nlists", {
  expect_identical(as_term_frame(nlists()), structure(list(term = structure(character(0), class = c(
    "term",
    "vctrs_vctr"
  )), sample = integer(0), value = numeric(0)), row.names = integer(0), class = "data.frame"))
  expect_identical(as_term_frame(nlists(nlist())), structure(list(term = structure(character(0), class = c(
    "term",
    "vctrs_vctr"
  )), sample = integer(0), value = numeric(0)), row.names = integer(0), class = "data.frame"))
  expect_identical(as_term_frame(nlists(nlist(x = 2))), structure(list(term = structure("x", class = c("term", "vctrs_vctr")), sample = 1L, value = 2), row.names = c(NA, -1L), class = "data.frame"))
  expect_identical(as_term_frame(nlists(nlist(x = 2:4))), structure(list(term = structure(c("x[1]", "x[2]", "x[3]"), class = c(
    "term",
    "vctrs_vctr"
  )), sample = c(1L, 1L, 1L), value = c(2, 3, 4)), row.names = c(
    NA,
    -3L
  ), class = "data.frame"))
  expect_identical(as_term_frame(nlists(nlist(y = 1, s = 1:2))), structure(list(term = structure(c("y", "s[1]", "s[2]"), class = c(
    "term",
    "vctrs_vctr"
  )), sample = c(1L, 1L, 1L), value = c(1, 1, 2)), row.names = c(
    NA,
    -3L
  ), class = "data.frame"))
  expect_equal(as_term_frame(nlists(nlist(x = 1, y = 1:2), nlist(x = 1, y = 3:4))), structure(list(term = structure(c(
    "x", "y[1]", "y[2]", "x", "y[1]",
    "y[2]"
  ), class = c("term", "vctrs_vctr")), sample = c(
    1L, 1L,
    1L, 2L, 2L, 2L
  ), value = c(1, 1, 2, 1, 3, 4)), row.names = c(
    NA,
    -6L
  ), class = "data.frame"))
})

test_that("fill_na.nlists", {
  expect_identical(
    fill_na(nlists()),
    nlists()
  )
  expect_identical(
    fill_na(nlists(nlist(x = c(2, NA)), nlist(x = c(NA_real_, NA)))),
    nlists(nlist(x = c(2, 0)), nlist(x = c(0, 0)))
  )
})

test_that("as_mcmc.mcmc.list", {
  expect_identical(as_mcmc(as_mcmc_list(nlists(nlist(x = 2), nlist(x = 3)))),
                   as_mcmc(nlists(nlist(x = 2), nlist(x = 3))))
})

test_that("as_mcmc.nlist", {
  expect_identical(
    as_mcmc(nlist()),
    structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlist(x = 1)),
    structure(1, .Dim = c(1L, 1L), .Dimnames = list(NULL, "x"), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlist(x = matrix(1:6, 2))),
    structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(NULL, c(
      "x[1,1]",
      "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]", "x[2,3]"
    )), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlist(x = 1:2, y = 3)),
    structure(c(1, 2, 3), .Dim = c(1L, 3L), .Dimnames = list(
      NULL,
      c("x[1]", "x[2]", "y")
    ), mcpar = c(1, 1, 1), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlist(x = NA_real_, y = 1)),
    structure(c(NA, 1), .Dim = 1:2, .Dimnames = list(NULL, c(
      "x",
      "y"
    )), mcpar = c(1, 1, 1), class = "mcmc")
  )

  expect_identical(
    as_mcmc(nlist::nlist(x = 1, y = matrix(1:4, 2))),
    structure(c(1, 1, 2, 3, 4), .Dim = c(1L, 5L), .Dimnames = list(
      NULL, c("x", "y[1,1]", "y[2,1]", "y[1,2]", "y[2,2]")
    ), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
})

test_that("as_mcmc.nlists", {
  expect_identical(
    as_mcmc(nlists()),
    structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlists(nlist())),
    structure(numeric(0), .Dim = 1:0, .Dimnames = list(NULL, NULL), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlists(nlist(), nlist())),
    structure(numeric(0), .Dim = c(2L, 0L), .Dimnames = list(
      NULL,
      NULL
    ), mcpar = c(1, 2, 1), class = "mcmc")
  )

  expect_identical(
    as_mcmc(nlists(nlist(x = 1))),
    structure(1, .Dim = c(1L, 1L), .Dimnames = list(NULL, "x"), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlists(nlist(x = 1), nlist(x = 3))),
    structure(c(1, 3), .Dim = 2:1, .Dimnames = list(NULL, "x"), mcpar = c(
      1,
      2, 1
    ), class = "mcmc")
  )
  expect_identical(
    as_mcmc(nlists(nlist(x = matrix(1:6, 2)))),
    structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(NULL, c(
      "x[1,1]",
      "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]", "x[2,3]"
    )), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )

  expect_identical(
    as_mcmc(nlists(
      nlist(x = matrix(1:6, 2)),
      nlist(x = matrix(3:8, 2))
    )),
    structure(c(1L, 3L, 2L, 4L, 3L, 5L, 4L, 6L, 5L, 7L, 6L, 8L), .Dim = c(
      2L,
      6L
    ), .Dimnames = list(NULL, c(
      "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]",
      "x[1,3]", "x[2,3]"
    )), mcpar = c(1, 2, 1), class = "mcmc")
  )
})

test_that("as.mcmc.nlist", {
  lifecycle::expect_deprecated(as.mcmc(nlist()))
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  
  expect_identical(
    as.mcmc(nlist()),
    structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlist(x = 1)),
    structure(1, .Dim = c(1L, 1L), .Dimnames = list(NULL, "x"), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlist(x = matrix(1:6, 2))),
    structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(NULL, c(
      "x[1,1]",
      "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]", "x[2,3]"
    )), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlist(x = 1:2, y = 3)),
    structure(c(1, 2, 3), .Dim = c(1L, 3L), .Dimnames = list(
      NULL,
      c("x[1]", "x[2]", "y")
    ), mcpar = c(1, 1, 1), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlist(x = NA_real_, y = 1)),
    structure(c(NA, 1), .Dim = 1:2, .Dimnames = list(NULL, c(
      "x",
      "y"
    )), mcpar = c(1, 1, 1), class = "mcmc")
  )
  
  expect_identical(
    as.mcmc(nlist::nlist(x = 1, y = matrix(1:4, 2))),
    structure(c(1, 1, 2, 3, 4), .Dim = c(1L, 5L), .Dimnames = list(
      NULL, c("x", "y[1,1]", "y[2,1]", "y[1,2]", "y[2,2]")
    ), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
})

test_that("as.mcmc.nlists", {
  lifecycle::expect_deprecated(as.mcmc(nlists()))
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    as.mcmc(nlists()),
    structure(numeric(0), mcpar = c(1, 0, 1), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlists(nlist())),
    structure(numeric(0), .Dim = 1:0, .Dimnames = list(NULL, NULL), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlists(nlist(), nlist())),
    structure(numeric(0), .Dim = c(2L, 0L), .Dimnames = list(
      NULL,
      NULL
    ), mcpar = c(1, 2, 1), class = "mcmc")
  )
  
  expect_identical(
    as.mcmc(nlists(nlist(x = 1))),
    structure(1, .Dim = c(1L, 1L), .Dimnames = list(NULL, "x"), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlists(nlist(x = 1), nlist(x = 3))),
    structure(c(1, 3), .Dim = 2:1, .Dimnames = list(NULL, "x"), mcpar = c(
      1,
      2, 1
    ), class = "mcmc")
  )
  expect_identical(
    as.mcmc(nlists(nlist(x = matrix(1:6, 2)))),
    structure(1:6, .Dim = c(1L, 6L), .Dimnames = list(NULL, c(
      "x[1,1]",
      "x[2,1]", "x[1,2]", "x[2,2]", "x[1,3]", "x[2,3]"
    )), mcpar = c(
      1,
      1, 1
    ), class = "mcmc")
  )
  
  expect_identical(
    as.mcmc(nlists(
      nlist(x = matrix(1:6, 2)),
      nlist(x = matrix(3:8, 2))
    )),
    structure(c(1L, 3L, 2L, 4L, 3L, 5L, 4L, 6L, 5L, 7L, 6L, 8L), .Dim = c(
      2L,
      6L
    ), .Dimnames = list(NULL, c(
      "x[1,1]", "x[2,1]", "x[1,2]", "x[2,2]",
      "x[1,3]", "x[2,3]"
    )), mcpar = c(1, 2, 1), class = "mcmc")
  )
})

test_that("collapse_chains nlist", {
  nlist <- nlist(x = matrix(1:6, 2))
  expect_identical(collapse_chains(nlist), nlist)
})

test_that("collapse_chains nlists", {
  nlists <- nlists(nlist(x = matrix(1:6, 2)), nlist(x = matrix(3:8, 2)))
  nlists2 <- nlists
  attr(nlists2, "nchains") <- 2L

  expect_identical(collapse_chains(nlists2), nlists)
})

test_that("thin", {
  expect_identical(
    thin(nlists(nlist(x = 1L), nlist(x = 2L), nlist(x = 3L), nlist(x = 4L)), nthin = 2),
    structure(list(structure(list(x = 1L), class = "nlist"), structure(list(
      x = 3L
    ), class = "nlist")), class = "nlists")
  )
})

test_that("as_nlists.mcmc", {
  expect_identical(
    as_nlists(as_mcmc(nlist(x = 1))),
    nlists(nlist(x = 1))
  )

  expect_identical(
    as_nlists(as_mcmc(nlists(nlist(x = 1), nlist(x = 2)))),
    nlists(nlist(x = 1), nlist(x = 2))
  )
  expect_identical(
    as_nlists(as_mcmc(nlists(nlist(x = 1:2), nlist(x = 2:3)))),
    nlists(nlist(x = 1:2), nlist(x = 2:3))
  )
})

test_that("as_nlists.mcmc", {
  nlists <- nlists(
    nlist(x = 1, y = matrix(1:4, 2)),
    nlist(x = 3, y = matrix(4:1, 2))
  )
  expect_equal(as_nlists(as_mcmc(nlists)), nlists)
})

test_that("as_nlists.mcmc.list 1 chain", {
  nlists <- nlists(
    nlist(x = 1, y = matrix(1:4, 2)),
    nlist(x = 3, y = matrix(4:1, 2))
  )
  expect_equal(as_nlists(as_mcmc_list(nlists)), nlists)
  expect_equal(nchains(as_nlists(as_mcmc_list(nlists))), 1L)
})

test_that("as_nlists.mcmc.list 2 chains", {
  nlists <- nlists(
    nlist(x = 1, y = matrix(1:4, 2)),
    nlist(x = 3, y = matrix(4:1, 2))
  )
  nlists <- split_chains(nlists)
  
  expect_equal(as_nlists(as_mcmc_list(nlists)), nlists)
  expect_equal(nchains(as_nlists(as_mcmc_list(nlists))), 2L)
})

test_that("as_nlists.nlists", {
  expect_identical(as_nlists(nlists()), nlists())
})

test_that("as_nlists.nlist", {
  expect_identical(
    as_nlists(nlist()),
    structure(list(structure(list(), .Names = character(0), class = "nlist")), class = "nlists")
  )
  expect_identical(
    as_nlists(nlist(x = 1)),
    structure(list(structure(list(x = 1), class = "nlist")), class = "nlists")
  )
})

test_that("as.nlists deprecated", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  lifecycle::expect_deprecated(as.nlists(nlist(x = 1)))

  expect_identical(
    as.nlists(nlist(x = 1)),
    as_nlists(nlist(x = 1))
  )
})

test_that("nchains nlist", {
  expect_identical(nchains(nlist()), 1L)
  expect_identical(nchains(nlist(x = 1)), 1L)
})

test_that("nchains nlists", {
  expect_identical(nchains(nlists()), 1L)
  expect_identical(nchains(nlists(nlist())), 1L)
  expect_identical(nchains(nlists(nlist(), nlist())), 1L)
  nlists <- nlists(nlist(x = 1), nlist(x = 3))
  attr(nlists, "nchains") <- 2L
  expect_identical(nchains(nlists), 2L)
})

test_that("subset.mcmc", {
  expect_equal(subset(as_mcmc(nlist(beta = 1:2, theta = 1))), 
                      as_mcmc(nlist(beta = 1:2, theta = 1)))
  expect_equal(subset(as_mcmc(nlist(beta = 1:2, theta = 1)), pars = "beta"), 
               as_mcmc(nlist(beta = 1:2)))
  
  expect_equal(subset(as_mcmc(nlists(nlist(beta = 1:2), nlist(beta = 3:4))), iters = 1),
                    as_mcmc(nlists(nlist(beta = 1:2))),
               ignore_attr = TRUE)

  expect_equal(subset(as_mcmc(nlists(nlist(beta = 1:2), nlist(beta = 3:4))), iters = c(1,1)),
                    as_mcmc(nlists(nlist(beta = 1:2), nlist(beta = 1:2))),
               ignore_attr = TRUE)
  
  skip("allow mcmc objects to be reodered by par")
  expect_equal(subset(as_mcmc(nlist(beta = 1:2, theta = 1)), pars = c("theta", "beta")), 
               as_mcmc(nlist(theta = 1:2, beta = 1))) 
})

test_that("subset.mcmc.list", {
  
  mcmc.list <- as_mcmc_list(nlists(nlist(beta = 1:2, theta = 1), 
                                   nlist(beta = 3:4, theta = -1)))
  expect_equal(subset(mcmc.list, pars = "beta"),
                   as_mcmc_list(nlists(nlist(beta = 1:2), 
                                       nlist(beta = 3:4))))
  expect_equal(subset(mcmc.list, iters = c(1L,1L)),
               as_mcmc_list(nlists(nlist(beta = 1:2, theta = 1), 
                                   nlist(beta = 1:2, theta = 1))),
               ignore_attr = TRUE)
  
  expect_equal(subset(as_mcmc_list(nlist(beta = 1:2, theta = 1)), pars = "beta"), 
                   as_mcmc_list(nlist(beta = 1:2)))
  expect_equal(subset(as_mcmc_list(nlists(nlist(beta = 1:2), nlist(beta = 3:4))), iters = 1),
                   as_mcmc_list(nlists(nlist(beta = 1:2))),
               ignore_attr = TRUE)
  
  nlists <- nlists(nlist(x = 1), nlist(x = 2))
  nlists <- split_chains(nlists)
  expect_equal(subset(as_mcmc_list(nlists), chains = 1:2),
                    as_mcmc_list(nlists))
  expect_equal(subset(as_mcmc_list(nlists), chains = 2),
                    as_mcmc_list(subset(nlists, chains = 2)),
               ignore_attr = TRUE)
})

test_that("subset.nlist", {
  expect_identical(subset(nlist()), nlist())
  expect_identical(subset(nlist(x = 1)), nlist(x = 1))
  expect_identical(subset(nlist(x = 1, y = 2), pars = "x"), nlist(x = 1))
  expect_identical(subset(nlist(x = 1, y = 2), pars = "y"), nlist(y = 2))
  expect_identical(subset(nlist(x = 1, y = 2), pars = c("y", "x")), nlist(y = 2, x = 1))
  expect_identical(subset(nlist(x = 1, y = 2), pars = c("x", "y")), nlist(x = 1, y = 2))
  expect_error(subset(nlist(x = 1, y = 2), pars = "z"),
    "^`pars` must match 'x' or 'y', not 'z'[.]$",
    class = "chk_error"
  )
})

test_that("subset.nlists pars and iters", {
  expect_identical(subset(nlists()), nlists())
  expect_identical(subset(nlists(nlist())), nlists(nlist()))
  expect_identical(subset(nlists(nlist(x = 1))), nlists(nlist(x = 1)))
  expect_identical(subset(nlists(nlist(x = 1, y = 2)), pars = "x"), nlists(nlist(x = 1)))
  expect_identical(subset(nlists(nlist(x = 1, y = 2)), pars = "y"), nlists(nlist(y = 2)))
  expect_identical(subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), pars = "x"), nlists(nlist(x = 1), nlist(x = 3)))
  expect_identical(
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), pars = c("y", "x")),
    subset(nlists(nlist(y = 2, x = 1), nlist(y = 2, x = 3)))
  )
  expect_identical(
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), iters = 1L),
    subset(nlists(nlist(x = 1, y = 2)))
  )
  expect_identical(
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), iters = c(1L, 1L)),
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 1, y = 2)))
  )
  expect_identical(
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), iters = c(2L, 1L)),
    subset(nlists(nlist(x = 3, y = 2), nlist(x = 1, y = 2)))
  )
  expect_identical(
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), iters = c(2L, 1L), pars = "x"),
    subset(nlists(nlist(x = 3), nlist(x = 1)))
  )
  expect_identical(
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), iters = integer(0)),
    subset(nlists())
  )
  expect_identical(
    subset(nlists(nlist(x = 1, y = 2), nlist(x = 3, y = 2)), iters = integer(0), pars = "x"),
    subset(nlists())
  )
  expect_error(subset(nlists(nlist(x = 1, y = 2)), pars = "z"),
    "^`pars` must match 'x' or 'y', not 'z'[.]$",
    class = "chk_error"
  )
})


test_that("subset with chains", {
  nlists <- nlists(nlist(x = 1, y = 2), nlist(x = 2, y = 3), nlist(x = 3, y = 4), nlist(x = 4, y = 5))
  attr(nlists, "nchains") <- 2L
  expect_identical(subset(nlists), nlists)
  expect_identical(
    subset(nlists, pars = c("y", "x")),
    structure(list(
      structure(list(y = 2, x = 1), class = "nlist"),
      structure(list(y = 3, x = 2), class = "nlist"), structure(list(
        y = 4, x = 3
      ), class = "nlist"), structure(list(
        y = 5,
        x = 4
      ), class = "nlist")
    ), class = "nlists", nchains = 2L)
  )
  expect_identical(
    subset(nlists, chains = c(1, 1, 1)),
    structure(list(
      structure(list(x = 1, y = 2), class = "nlist"),
      structure(list(x = 2, y = 3), class = "nlist"), structure(list(
        x = 1, y = 2
      ), class = "nlist"), structure(list(
        x = 2,
        y = 3
      ), class = "nlist"), structure(list(x = 1, y = 2), class = "nlist"),
      structure(list(x = 2, y = 3), class = "nlist")
    ), class = "nlists", nchains = 3L)
  )
  expect_identical(
    subset(nlists, pars = "x", iters = c(2, 2)),
    structure(list(
      structure(list(x = 2), class = "nlist"), structure(list(
        x = 2
      ), class = "nlist"), structure(list(x = 4), class = "nlist"),
      structure(list(x = 4), class = "nlist")
    ), class = "nlists", nchains = 2L)
  )
})

test_that("chk_nlist", {
  expect_error(chk_nlist(NULL),
    "^`NULL` must inherit from S3 class 'nlist'[.]$",
    class = "chk_error"
  )
  expect_false(vld_nlist(list()))
  expect_false(vld_nlist(list(x = 1, x = 2)))
  expect_error(chk_nlist(list(x = 1, x = 2)), "^`list[(]x = 1, x = 2[)]` must inherit from S3 class 'nlist'[.]$", class = "chk_error")
  expect_true(vld_nlist(nlist(x = 1, y = 2)))
  expect_true(vld_nlist(nlist(x = 1)[-1]))
  expect_true(vld_nlist(nlist()))
  expect_true(vld_nlist(nlist(x = 1)))
  expect_false(vld_nlist(list(x = TRUE)))
  expect_error(chk_nlist(list(x = TRUE)),
    "`list[(]x = TRUE[)]` must inherit from S3 class 'nlist'[.]",
    class = "chk_error"
  )
  x <- list(x = "x")
  class(x) <- "nlist"
  expect_false(vld_nlist(x))
})

test_that("chk_nlists", {
  expect_error(chk_nlists(list()), "^`list[(][)]` must inherit from S3 class 'nlists'[.]$", class = "chk_error")
  expect_true(vld_nlists(nlists()))
  expect_error(chk_nlists(list(nlist(x = 1))), "^`[^`]+` must inherit from S3 class 'nlists'[.]$", class = "chk_error")
  expect_true(vld_nlists(nlists(nlist())))
  expect_true(vld_nlists(nlists(nlist(x = 1), nlist(x = 2))))
  expect_true(vld_nlists(nlists(nlist(x = 1), nlist(x = 2))))
  expect_error(nlists(nlist(x = 1), nlist(y = 2)),
    "^nlist elements of `x` must have matching names[.]",
    class = "chk_error"
  )
  expect_error(nlists(nlist(x = 1), nlist(x = 1L)),
    "^nlist elements of `x` must have matching types[.]",
    class = "chk_error"
  )
  expect_error(nlists(nlist(x = 1L), nlist(x = 1:2)),
    "^nlist elements of `x` must have matching dimensions[.]",
    class = "chk_error"
  )
  x <- list(x = "x")
  class(x) <- "nlist"
  expect_error(chk_nlist(x), "All elements of `x` must be numeric.",
    class = "chk_error"
  )
  x <- list("x")
  class(x) <- "nlist"
  expect_error(chk_nlist(x), "`x` must be named.", class = "chk_error")
})

test_that("anyNA.nlist", {
  expect_false(anyNA(nlist()))
  expect_false(anyNA(nlist(x = 1)))
  expect_true(anyNA(nlist(x = 1, y = NA)))
})

test_that("anyNA.nlists", {
  expect_false(anyNA(nlists()))
  expect_false(anyNA(nlists(nlist(x = 1))))
  expect_true(anyNA(nlists(nlist(x = 1, y = NA))))
})

test_that("estimates.nlist", {
  expect_identical(estimates(nlist()), structure(list(), .Names = character(0), class = "nlist"))
  expect_identical(estimates(nlist(x = 1)), nlist(x = 1))
  expect_identical(estimates(nlist(x = 1:2)), nlist(x = 1:2))
  expect_identical(estimates(nlist(z = 1:2), fun = median), nlist(z = 1:2))
  expect_identical(estimates(nlist(z = 1:2), fun = function(x) 1L), nlist(z = c(1L, 1L)))
  expect_identical(estimates(nlist(z = 1:2), fun = function(x, value) {
    value
  }, value = 2.5), nlist(z = c(2.5, 2.5)))

  expect_error(
    estimates(nlist(x = 1:2), fun = function(x) 1:2),
    "^`fun` must return a scalar[.]$",
    class = "chk_error"
  )
})

test_that("estimates.nlists", {
  expect_identical(
    estimates(nlists()),
    structure(list(), .Names = character(0), class = "nlist")
  )
  expect_identical(
    estimates(nlists(nlist())),
    structure(list(), .Names = character(0), class = "nlist")
  )
  expect_identical(estimates(nlists(nlist(x = 1), nlist(x = 2))), nlist(x = 1.5))
  expect_identical(
    estimates(nlists(
      nlist(x = matrix(1:9, 3)),
      nlist(x = matrix(2:10, 3))
    )),
    structure(list(x = structure(c(
      1.5, 2.5, 3.5, 4.5, 5.5, 6.5,
      7.5, 8.5, 9.5
    ), .Dim = c(3L, 3L))), class = "nlist")
  )
  expect_identical(estimates(nlists(nlist(x = 1), nlist(x = 2)), fun = function(x) x[1]), nlist(x = 1))

  expect_identical(estimates(nlists(nlist(x = 1), nlist(x = 2)), fun = function(x, value) value, value = 3), nlist(x = 3))

  expect_error(
    estimates(nlists(
      nlist(x = matrix(1:9, 3)),
      nlist(x = matrix(2:10, 3))
    ), fun = identity),
    "^`fun` must return a scalar[.]$",
    class = "chk_error"
  )
})

test_that("aggregate.nlist", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(aggregate(nlist()), structure(list(), .Names = character(0)))
  expect_identical(aggregate(nlist(x = 1)), list(x = 1))
  expect_identical(aggregate(nlist(x = 1:2)), list(x = 1.5))
  expect_identical(aggregate(nlist(x = 1:2), fun = function(x) x[1]), list(x = 1L))
  expect_identical(aggregate(nlist(x = matrix(1:9, 3)), fun = function(x) x[1]), list(x = 1L))
  expect_identical(aggregate(nlist(x = 1:3, y = matrix(1:9, 3))), list(x = 2, y = 5))

  expect_error(
    aggregate(nlist(x = 1:2), fun = identity),
    "^`fun` must return a scalar[.]$",
    class = "chk_error"
  )
})

test_that("aggregate.nlists", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    aggregate(nlists()),
    structure(list(), .Names = character(0), class = "nlist")
  )
  expect_identical(
    aggregate(nlists(nlist())),
    structure(list(), .Names = character(0), class = "nlist")
  )
  expect_identical(aggregate(nlists(nlist(x = 1), nlist(x = 2))), nlist(x = 1.5))
  expect_identical(
    aggregate(nlists(
      nlist(x = matrix(1:9, 3)),
      nlist(x = matrix(2:10, 3))
    )),
    structure(list(x = structure(c(
      1.5, 2.5, 3.5, 4.5, 5.5, 6.5,
      7.5, 8.5, 9.5
    ), .Dim = c(3L, 3L))), class = "nlist")
  )
})

test_that("aggregate.nlists", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_error(
    aggregate(nlists(
      nlist(x = matrix(1:9, 3)),
      nlist(x = matrix(2:10, 3))
    ), fun = identity),
    "^`fun` must return a scalar[.]$",
    class = "chk_error"
  )
})

test_that("aggregate.nlists by_chain = TRUE", {
  rlang::scoped_options(lifecycle_verbosity = "quiet")
  expect_identical(
    aggregate(nlists(), by_chain = TRUE),
    structure(list(), class = "nlists")
  )
  expect_identical(
    aggregate(nlists(nlist()), by_chain = TRUE),
    structure(list(structure(list(), .Names = character(0), class = "nlist")), class = "nlists")
  )
  expect_identical(
    aggregate(nlists(nlist(x = 1), nlist(x = 2)), by_chain = TRUE),
    structure(list(structure(list(x = 1.5), class = "nlist")), class = "nlists")
  )
  expect_identical(
    aggregate(nlists(
      nlist(x = matrix(1:9, 3)),
      nlist(x = matrix(2:10, 3))
    ), by_chain = TRUE),
    structure(list(structure(list(x = structure(c(
      1.5, 2.5,
      3.5, 4.5, 5.5, 6.5, 7.5, 8.5, 9.5
    ), .Dim = c(3L, 3L))), class = "nlist")), class = "nlists")
  )
  nlists <- nlists(nlist(x = matrix(1:9, 3)), nlist(x = matrix(2:10, 3)))
  attr(nlists, "nchains") <- 2L
  expect_equal(aggregate(nlists, by_chain = TRUE), nlists)
})

test_that("complete_terms 1 iteration", {
  mcmc <- as_mcmc(nlist(beta = matrix(1:4, nrow = 2)))
  expect_identical(complete_terms(mcmc), mcmc)
  mcmc[, "beta[2,2]"] <- NA
  expect_identical(complete_terms(mcmc), mcmc)
  mcmc2 <- mcmc
  mcmc2 <- mcmc2[, -4,drop = FALSE]
  expect_identical(complete_terms(mcmc2), mcmc)
})

test_that("complete_terms 2 iterations", {
  mcmc <- as_mcmc(nlists(nlist(beta = matrix(1:4, nrow = 2)), 
                          nlist(beta = matrix(1:4, nrow = 2))))
  expect_identical(complete_terms(mcmc), mcmc)
  mcmc[, "beta[2,2]"] <- NA
  expect_identical(complete_terms(mcmc), mcmc)
  mcmc2 <- mcmc
  mcmc2 <- mcmc2[, -4]
  expect_identical(complete_terms(mcmc2), mcmc)
})

test_that("complete_terms mcmc 1 digit", {
  mcmc <- as_mcmc(nlists(nlist(x = 1), nlist(x = 2)))
  colnames(mcmc) <- "1"
  expect_warning(complete_terms(mcmc))
})

test_that("", {
  expect_identical(
    fill_all(nlist(x = c(2, NA), y = matrix(c(1:3, NA), nrow = 2))),
    structure(list(x = c(0, 0), y = structure(c(0L, 0L, 0L, 0L), .Dim = c(
      2L,
      2L
    ))), class = "nlist")
  )
  expect_identical(fill_all(nlist(x = c(2, NA), y = matrix(c(1:3, NA), nrow = 2)), nas = FALSE), structure(list(x = c(0, NA), y = structure(c(0L, 0L, 0L, NA), .Dim = c(
    2L,
    2L
  ))), class = "nlist"))

  expect_identical(
    fill_all(nlists(nlist(x = c(2, NA)), nlist(x = c(NA_real_, NA)))),
    structure(list(
      structure(list(x = c(0, 0)), class = "nlist"),
      structure(list(x = c(0, 0)), class = "nlist")
    ), class = "nlists")
  )
  expect_identical(fill_all(nlists(nlist(x = c(2, NA)), nlist(x = c(NA_real_, NA))), nas = FALSE), structure(list(
    structure(list(x = c(0, NA)), class = "nlist"),
    structure(list(x = c(NA_real_, NA_real_)), class = "nlist")
  ), class = "nlists"))
})
